#include <PCF8574.h>

/* PCF8574P
 * Porta 0 - Vermelho
 * Porta 1 - Amarelo
 * Porta 2 - Verde
 * Porta 3 - Amarelo Prudência para virar à esquerda
 * Porta 4 - Vermelho
 * Porta 5 - Amarelo
 * Porta 6 - Verde
 * Porta 7 - Amarelo Prudência para virar à esquerda * 
 */

 PCF8574 pcf_Veiculos(0x38); // Endereço do PCF8574P
 int temp1 = 3000;  // Tempo que o semáforo verde vai estar ligado
 int temp2 = 250;   // Tempo dado ao sinal intermitente

void setup() {
  Serial.begin(9600);  
  for(int i=0; i<=7; i++){ // pinMode das portas do PCF8574P
    pcf_Veiculos.pinMode(i, OUTPUT);
  }
  pcf_Veiculos.begin();

  // Inicializar semáforos
  // Garantir que todos os semáforos estão desligados
  for(int i=0; i<=7; i++){ 
    pcf_Veiculos.digitalWrite(i, LOW);
  }
}

void loop() {
  /* ligar os semáforos para os veículos
     O primeiro passo é ligar o vermelho de um dos semáforos e ao 
     mesmo tempo ligar o verde e o amarelo de prudência no semáforo 
     oposto */
  pcf_Veiculos.digitalWrite(0, HIGH);
  pcf_Veiculos.digitalWrite(6, HIGH);
  pcf_Veiculos.digitalWrite(7, HIGH);
  delay(temp1);
  // Desliga o semáforo verde e liga o amarelo intermitente  
  pcf_Veiculos.digitalWrite(6, LOW);
  for(int j=0; j<=6; j++){
    pcf_Veiculos.digitalWrite(5, HIGH);
    delay(temp2);
    pcf_Veiculos.digitalWrite(5, LOW);
    delay(temp2);    
  }
  // Desliga os LEDs Amarelo e Vermelho e Liga o Vermelho e 
  // o verde e Amarelo do semáforo oposto
  pcf_Veiculos.digitalWrite(0, LOW);
  pcf_Veiculos.digitalWrite(7, LOW);
  pcf_Veiculos.digitalWrite(4, HIGH);
  pcf_Veiculos.digitalWrite(2, HIGH);
  pcf_Veiculos.digitalWrite(3, HIGH);
  delay(temp1);
  // Desliga o semáforo verde e liga o amarelo intermitente  
  pcf_Veiculos.digitalWrite(2, LOW);
  for(int j=0; j<=6; j++){
    pcf_Veiculos.digitalWrite(1, HIGH);
    delay(temp2);
    pcf_Veiculos.digitalWrite(1, LOW);
    delay(temp2);    
  }
  // Desliga os LEDs Amarelo e Vermelho
  pcf_Veiculos.digitalWrite(4, LOW);
  pcf_Veiculos.digitalWrite(3, LOW); 
}
